unit Tst;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Explorer, StdCtrls, ExtCtrls, ColorGrd;

type

  TTEST = class(TForm)
    EXP: TExplorer;
    ChangeRoot: TButton;
    TstImg: TImage;
    Clr: TColorGrid;
    Img2: TImage;
    plusBmp: TImage;
    Minus: TImage;
    FP: TEdit;
    ReOpen: TButton;
    RescanBtn: TButton;
    RtPath: TButton;
    ChgMask: TButton;
    procedure ScanClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ChangeRootClick(Sender: TObject);
    procedure ClrChange(Sender: TObject);
    procedure EXPDblClk(Sender: TObject);
    procedure EXPSelectBitmap(fName: String; var bmp: TBitmap;
      var Transparent: TColor);
    procedure ReOpenClick(Sender: TObject);
    procedure RescanBtnClick(Sender: TObject);
    procedure EXPChange(Sender: TObject);
    procedure Edit1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure RtPathClick(Sender: TObject);
    procedure ChgMaskClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TEST: TTEST;

implementation

{$R *.DFM}

procedure TTEST.ScanClick(Sender: TObject);
begin
EXP.testStuff;
end;

procedure TTEST.FormResize(Sender: TObject);
begin
EXP.Width := ClientWidth - 20;
EXP.Height := ClientHeight - 150;
end;

procedure TTEST.ChangeRootClick(Sender: TObject);
begin
EXP.RootName := FP.Text;
end;


procedure TTEST.ClrChange(Sender: TObject);
begin
EXP.COlor := Clr.ForeGroundColor;
end;

procedure TTEST.EXPDblClk(Sender: TObject);
begin
FP.Text := EXP.FullPath;
end;

procedure TTEST.EXPSelectBitmap(fName: String; var bmp: TBitmap;
  var Transparent: TColor);
var
  ext : String;
begin
Transparent := clNavy;
  if fName = ':+' then
    begin
    bmp := plusBmp.Picture.Bitmap;
    end
  else if fName = ':-' then
    begin
    bmp := Minus.Picture.Bitmap;
    Transparent := clBlack;
    end
  else
    begin
    ext := ExtractFileExt( fName );
    if (ext = '.lnk') then
      bmp := TstImg.Picture.Bitmap;
    if (ext = '.ini') then
      bmp := Img2.Picture.Bitmap;
    end;
end;

procedure TTEST.ReOpenClick(Sender: TObject);
begin
EXP.FullPath := FP.Text;
end;

procedure TTEST.RescanBtnClick(Sender: TObject);
begin
EXP.ReScan;
end;

procedure TTEST.EXPChange(Sender: TObject);
begin
FP.Text := EXP.FullPath;
end;

procedure TTEST.Edit1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
Accept := True;
end;

procedure TTEST.RtPathClick(Sender: TObject);
begin
EXP.RootPath := FP.Text;
end;

procedure TTEST.ChgMaskClick(Sender: TObject);
begin
if ChgMask.Caption = 'Get Mask' then
  begin
  FP.Text := EXP.FileMask;
  ChgMask.Caption := 'Set Mask';
  end
else
  begin
  EXP.FileMask := FP.Text;
  ChgMask.Caption := 'Get Mask';
  EXP.Rescan;
  end;
end;

end.
